SystemOrganization addCategory: #'Continuations-Test'!
SystemOrganization addCategory: #'Continuations-Utils'!
SystemOrganization addCategory: #Continuations!

PluggableListSpec subclass: #SDMultiLineListSpec
	instanceVariableNames: 'numberOfRowsPerLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Continuations-Utils'!

!SDMultiLineListSpec class methodsFor: 'class name' stamp: 'tfel 1/4/2012 15:38'!
listClass

	^ SDPluggableMultiLineListMorphPlus! !

!SDMultiLineListSpec methodsFor: 'building' stamp: 'tfel 12/27/2011 19:03'!
buildWith: builder
	| widget listClass getIndex setIndex |
	self getSelected ifNil:[
		listClass := self listClass.
		getIndex := self getIndex.
		setIndex := self setIndex.
	] ifNotNil:[
		listClass := self listByItemClass.
		getIndex := self getSelected.
		setIndex := self setSelected.
	].
	widget := listClass on: self model
				list: self list
				selected: getIndex
				changeSelected: setIndex
				menu: self menu
				keystroke: self keyPress.
	builder register: widget id: self name.
	widget getListElementSelector: self listItem.
	widget getListSizeSelector: self listSize.
	widget doubleClickSelector: self doubleClick.
	widget autoDeselect: self autoDeselect.
	widget keystrokePreviewSelector: self keystrokePreview.
	widget numberOfRows: self numberOfRowsPerLine.
	self color isNil ifFalse: [widget color: self color].
	builder buildHelpFor: widget spec: self. 
	builder setFrame: self frame in: widget.
	builder parent ifNotNil:[builder add: widget to: builder parent].
	"builder panes ifNotNil:[
		self list ifNotNil:[builder panes add: self list].
	]."
	^ widget
! !

!SDMultiLineListSpec methodsFor: 'building' stamp: 'tfel 12/27/2011 16:44'!
listByItemClass

	^ PluggableListMorphByItemPlus! !

!SDMultiLineListSpec methodsFor: 'building' stamp: 'tfel 1/4/2012 15:38'!
listClass

	^ self class listClass! !

!SDMultiLineListSpec methodsFor: 'accessing' stamp: 'tfel 12/27/2011 19:03'!
numberOfRowsPerLine
	"Answer the value of numberOfRowsPerLine"

	^ numberOfRowsPerLine! !

!SDMultiLineListSpec methodsFor: 'accessing' stamp: 'tfel 12/27/2011 19:03'!
numberOfRowsPerLine: anObject
	"Set the value of numberOfRowsPerLine"

	numberOfRowsPerLine := anObject! !

LazyListMorph subclass: #SDMultiLineLazyListMorph
	instanceVariableNames: 'numberOfRows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Continuations-Utils'!

!SDMultiLineLazyListMorph methodsFor: 'drawing' stamp: 'tfel 12/27/2011 19:01'!
adjustHeight
	"private.  Adjust our height to match the length of the underlying list"
	self height: (listItems size max: 1) * self fontHeight.
! !

!SDMultiLineLazyListMorph methodsFor: 'drawing' stamp: 'tfel 1/4/2012 09:43'!
display: items atRow: row on: canvas
	"display the given item at row row"
	| rowBounds drawBounds emphasis |
	rowBounds := self drawBoundsForRow: row.
	(items first: (items size min: self numberOfRows - 1)) withIndexDo: [:item :idx |
		drawBounds := rowBounds copy.
		drawBounds := drawBounds top: rowBounds top + (self font height * (idx - 1)).
		drawBounds := drawBounds bottom: drawBounds top + self font height.
		drawBounds := drawBounds intersect: self bounds.
		emphasis := item isText ifTrue: [item emphasisAt: 1] ifFalse: [0].
		canvas drawString: item in: drawBounds font: (font emphasized: emphasis) color: (self colorForRow: row)].
	(rowBounds := (rowBounds intersect: self bounds)) hasPositiveExtent ifTrue: [
		canvas line: rowBounds bottomLeft to: rowBounds bottomRight color: Color gray].
! !

!SDMultiLineLazyListMorph methodsFor: 'list management' stamp: 'tfel 12/27/2011 18:54'!
drawBoundsForRow: row
	"calculate the bounds that row should be drawn at.  This might be outside our bounds!!"
	| topLeft drawBounds |
	topLeft := self topLeft x @ (self topLeft y + ((row - 1) * (self fontHeight))).
	drawBounds := topLeft extent: self width @ self fontHeight.
	^drawBounds! !

!SDMultiLineLazyListMorph methodsFor: 'drawing' stamp: 'tfel 12/27/2011 19:18'!
drawOn: aCanvas
	self getListSize = 0 ifTrue:[ ^self ].
	self drawSelectionOn: aCanvas.

	(self topVisibleRowForCanvas: aCanvas) to: (self bottomVisibleRowForCanvas: aCanvas) do: [ :row |
		(listSource itemSelectedAmongMultiple:  row) ifTrue: [
			self drawBackgroundForMulti: row on: aCanvas. ].
		self display: (self item: row) atRow: row on: aCanvas.
	].

	listSource potentialDropRow > 0 ifTrue: [
		self highlightPotentialDropRow: listSource potentialDropRow on: aCanvas ].
! !

!SDMultiLineLazyListMorph methodsFor: 'accessing' stamp: 'tfel 12/27/2011 18:57'!
fontHeight

	^ self font height * self numberOfRows ceiling
! !

!SDMultiLineLazyListMorph methodsFor: 'initialization' stamp: 'tfel 1/11/2012 10:13'!
initialize
	
	super initialize.
	self font: Preferences standardCodeFont.
! !

!SDMultiLineLazyListMorph methodsFor: 'accessing' stamp: 'tfel 1/4/2012 09:43'!
numberOfRows
	"Answer the value of numberOfRows"
	^ numberOfRows ifNil: [2]
! !

!SDMultiLineLazyListMorph methodsFor: 'accessing' stamp: 'tfel 12/27/2011 16:56'!
numberOfRows: aNumber

	numberOfRows := aNumber! !

!SDMultiLineLazyListMorph methodsFor: 'list management' stamp: 'tfel 12/27/2011 16:54'!
rowAtLocation: aPoint
	"return the number of the row at aPoint"
	| y |
	y := aPoint y.
	y < self top ifTrue: [ ^ 1 ].
	^((y - self top // (self fontHeight)) + 1) min: listItems size max: 0! !

!SDMultiLineLazyListMorph methodsFor: 'scroll range' stamp: 'tfel 12/27/2011 17:09'!
widthToDisplayItem: item

	^ item inject: 0 into: [:acc :each | acc max: (super widthToDisplayItem: each) ]
! !

Debugger subclass: #SDDebugger
	instanceVariableNames: 'history historyIndex packageFilter classFilter methodFilter transcriptBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Continuations-Utils'!

!SDDebugger class methodsFor: 'instance creation' stamp: 'tfel 1/2/2012 09:10'!
openOn: aProcess

	^ self openOn: aProcess filters: Dictionary new! !

!SDDebugger class methodsFor: 'instance creation' stamp: 'tfel 1/11/2012 09:47'!
openOn: aProcess filters: aDictionary
	| errorWasInUIProcess |
	errorWasInUIProcess := Project spawnNewProcessIfThisIsUI: aProcess.
	aProcess suspend.
	^ self new
		process: aProcess controller: nil context: aProcess suspendedContext;
		openFullNoSuspendLabel: aProcess printString;
		errorWasInUIProcess: errorWasInUIProcess;
		packageFilter: (aDictionary at: #packageFilter ifAbsent: [#('*')]);
		classFilter: (aDictionary at: #classFilter ifAbsent: [#('*')]);
		methodFilter: (aDictionary at: #methodFilter ifAbsent: [#()]);
		changed: #contextStackList;
		next;
		yourself
! !

!SDDebugger class methodsFor: 'instance creation' stamp: 'tfel 1/3/2012 12:07'!
run: aBlock

	^ SDDebugger run: aBlock filters: Dictionary new! !

!SDDebugger class methodsFor: 'instance creation' stamp: 'tfel 1/3/2012 12:06'!
run: aBlock filters: aDictionary

	^ SDDebugger
		openOn: aBlock newProcess
		filters: aDictionary
! !

!SDDebugger class methodsFor: 'class name' stamp: 'tfel 1/4/2012 15:36'!
stackListSpec

	^ SDMultiLineListSpec! !

!SDDebugger methodsFor: 'misc' stamp: 'tfel 1/2/2012 09:29'!
addModelItemsToWindowMenu: aMenu
	"Add model-related items to the window menu"
	super addModelItemsToWindowMenu: aMenu.
	aMenu
		addLine;
		add: 'Package Filter' target: self action: #setPackageFilter;
		add: 'Class Filter' target: self action: #setClassFilter;
		add: 'Method Filter' target: self action: #setMethodFilter.
! !

!SDDebugger methodsFor: 'transcript' stamp: 'tfel 1/4/2012 10:51'!
annotation

	^ self transcriptBuffer contents! !

!SDDebugger methodsFor: 'toolbuilder' stamp: 'tfel 1/4/2012 10:47'!
buildDebuggerTranscriptWith: builder

	self initializeTranscriptBuffer.
	^ builder pluggableTextSpec new
			model: self;
			getText: #annotation;
			yourself
! !

!SDDebugger methodsFor: 'toolbuilder' stamp: 'tfel 1/4/2012 11:07'!
buildFullWith: builder
	| windowSpec |
	
	windowSpec := self buildWindowWith: builder specs: {
		(0@0 corner: 0.3@1) -> [self buildStackPaneWith: builder].
		(0.3@0 corner: 1@0.6) -> [self buildCodePaneWith: builder].
		(0.3@0.6 corner: 0.44@0.8) -> [self buildReceiverInspectorWith: builder].
		(0.44@0.6 corner: 0.65@0.8) -> [self buildReceiverEvaluatorWith: builder].
		(0.65@0.6 corner: 0.79@0.8) -> [self buildVariablesInspectorWith: builder].
		(0.79@0.6 corner: 1@0.8) -> [self buildVariablesEvaluatorWith: builder] .
		(0.3@0.8 corner: 1@1) -> [self buildDebuggerTranscriptWith: builder] }.
	^ builder build: windowSpec
! !

!SDDebugger methodsFor: 'toolbuilder' stamp: 'tfel 12/27/2011 11:53'!
buildReceiverEvaluatorWith: builder

	^ builder pluggableTextSpec new
			model: self receiverInspector;
			getText: #contents; 
			setText: #accept:; 
			selection: #contentsSelection; 
			menu: #codePaneMenu:shifted:;
			yourself
! !

!SDDebugger methodsFor: 'toolbuilder' stamp: 'tfel 12/27/2011 11:52'!
buildReceiverInspectorWith: builder

	^ builder pluggableListSpec new
			model: self receiverInspector;
			list: #fieldList; 
			getIndex: #selectionIndex; 
			setIndex: #toggleIndex:; 
			menu: #fieldListMenu:; 
			keyPress: #inspectorKey:from:;
			yourself
! !

!SDDebugger methodsFor: 'toolbuilder' stamp: 'tfel 1/11/2012 10:05'!
buildStackPaneWith: builder

	^ self class stackListSpec new
				model: self;
				list: #contextStackList; 
				getIndex: #contextStackIndex; 
				setIndex: #toggleContextStackIndex:; 
				menu: #contextStackMenu:shifted:; 
				keyPress: #contextStackKey:from:;
				numberOfRowsPerLine: 7;
				yourself
! !

!SDDebugger methodsFor: 'toolbuilder' stamp: 'tfel 12/27/2011 11:55'!
buildVariablesEvaluatorWith: builder

	^ builder pluggableTextSpec new
			model: self contextVariablesInspector;
			getText: #contents; 
			setText: #accept:; 
			selection: #contentsSelection; 
			menu: #codePaneMenu:shifted:;
			yourself
! !

!SDDebugger methodsFor: 'toolbuilder' stamp: 'tfel 12/27/2011 11:54'!
buildVariablesInspectorWith: builder

	^ builder pluggableListSpec new
			model: self contextVariablesInspector;
			list: #fieldList; 
			getIndex: #selectionIndex; 
			setIndex: #toggleIndex:; 
			menu: #fieldListMenu:; 
			keyPress: #inspectorKey:from:;
			yourself
! !

!SDDebugger methodsFor: 'toolbuilder' stamp: 'tfel 12/27/2011 12:06'!
buildWindowWith: builder specs: specs

	^ (super buildWindowWith: builder specs: specs)
		model: self;
		label: 'Stack Debugger';
		extent: self windowExtent;
		yourself! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 1/2/2012 08:55'!
classFilter

	^ classFilter ifNil: [classFilter := #('*')]
! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 12/27/2011 10:28'!
classFilter: anObject
	"Set the value of classFilter"

	classFilter := anObject! !

!SDDebugger methodsFor: 'context stack (message list)' stamp: 'tfel 1/4/2012 19:44'!
contextStackList
	self flag: #tfel. "slow"
	^ (self filteredContextStack reverse withIndexCollect: [:ctxt :idx || position padding |
		position := idx printString.
		padding := String streamContents: [:s |
						position size to: 2 do: [:i | s nextPut: Character space]].
		{ position, ':', padding, ctxt printString },
			ctxt tempsAndValuesList collect: [:str |
				(Text fromString: str) addAttribute: TextEmphasis italic]]) reverse
! !

!SDDebugger methodsFor: 'context stack menu' stamp: 'tfel 1/4/2012 15:26'!
contextStackMenu: aMenu shifted: shifted

	shifted ifFalse: [aMenu addList: { {'Pin Stack'. #pinStack}. #-. }].
	^ super contextStackMenu: aMenu shifted: shifted
! !

!SDDebugger methodsFor: 'initialize' stamp: 'tfel 1/3/2012 16:36'!
customButtonSpecs
	"Answer an array of elements of the form wording, selector, help-message, that characterize the custom button row of a debugger."

	| list |
	list := #((' Return'	return		'Run to previous frame')
		(' Previous'	previous	'"Unstep" back to previous frame')
		(' Next'		next		'Step to next frame')
		('... Step'		safeStep	'Step to next instruction')
		('Skip method' skip	'Step to next frame and skip this method from now on')).
	^ list
! !

!SDDebugger methodsFor: 'context stack (message list)' stamp: 'tfel 1/2/2012 11:41'!
filterMatches: aContext
	| class method packageOfClass packageOfMethod |
	aContext isContext ifFalse: [^ false].
	class := aContext methodClass name.
	packageOfClass := (PackageOrganizer default packageOfClass: aContext methodClass) packageName.
	packageOfMethod := (PackageOrganizer default packageOfMethod:
		(MethodReference class: aContext methodClass selector: aContext selector)) packageName.
	method := aContext selector asString.
	^ (self packageFilter anySatisfy: [:f | (f match: packageOfClass) or: [f match: packageOfMethod]])
		and: [self classFilter anySatisfy: [:f | f match: class]]
		and: [self methodFilter noneSatisfy: [:f | f match: class, '>>', method]]
! !

!SDDebugger methodsFor: 'context stack (message list)' stamp: 'tfel 1/4/2012 19:44'!
filteredContextStack
	self flag: #tfel. "slow"
	^ self contextStackTop contextStack
		select: [:ctxt | self filterMatches: ctxt]! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 12/27/2011 13:41'!
history
	"Answer the value of history"

	^ history! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 12/27/2011 13:41'!
history: anObject
	"Set the value of history"

	history := anObject! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 12/27/2011 13:41'!
historyIndex
	"Answer the value of historyIndex"

	^ historyIndex! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 12/27/2011 13:41'!
historyIndex: anObject
	"Set the value of historyIndex"

	historyIndex := anObject! !

!SDDebugger methodsFor: 'initialize' stamp: 'tfel 12/27/2011 13:42'!
initialize

	super initialize.
	self
		history: (OrderedCollection new);
		historyIndex: 1.
! !

!SDDebugger methodsFor: 'transcript' stamp: 'tfel 1/4/2012 10:54'!
initializeTranscriptBuffer

	self transcriptBuffer: (WriteStream on: String new).
	Transcript addDependent: self.
! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 1/2/2012 09:28'!
methodFilter
	"Answer the value of methodFilter"

	^ methodFilter ifNil: [methodFilter := #()]! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 1/2/2012 08:52'!
methodFilter: anObject
	"Set the value of methodFilter"

	methodFilter := anObject! !

!SDDebugger methodsFor: 'commands' stamp: 'tfel 1/3/2012 11:53'!
next
	| newContext |
	self historyIndex = 1
		ifTrue: [| oldContext |
			oldContext := self contextStackTop.
			newContext := #invalid.
			[(newContext = nil or: [self filterMatches: newContext]) and: [oldContext ~= newContext]] whileFalse: [
				self interruptedProcess isTerminated ifTrue: [^ self changed: #flash].
				newContext := self interruptedProcess
					stepToSendOrReturn;
					step].
			self history addFirst: newContext copyStack]
		ifFalse: [
			newContext := self history at: self historyIndex.
			self historyIndex: self historyIndex - 1].
	self interruptedProcess install: newContext.
	self resetContext: newContext.
! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 1/2/2012 09:21'!
packageFilter

	^ packageFilter ifNil: [packageFilter := #('*')]
! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 12/27/2011 10:28'!
packageFilter: anObject
	"Set the value of packageFilter"

	packageFilter := anObject! !

!SDDebugger methodsFor: 'commands' stamp: 'tfel 1/4/2012 19:47'!
pinStack
	| pane form |
	self flag: #tfel. "ugly"
	pane := self dependents detect: [:view |
		view isKindOf: self class stackListSpec listClass].
	form := pane imageForm asMorph.
	pane addMorph: form.
	form right: pane bounds left.
	form top: pane top.
! !

!SDDebugger methodsFor: 'commands' stamp: 'tfel 12/27/2011 13:46'!
previous
	| newContext |
	self historyIndex < self history size ifFalse: [^ self changed: #flash].
	self historyIndex: self historyIndex + 1.
	newContext := self history at: self historyIndex.
	self interruptedProcess install: newContext.
	self resetContext: newContext.

! !

!SDDebugger methodsFor: 'private' stamp: 'tfel 1/2/2012 09:33'!
request: aString with: aDefaultList do: aBlock

	aBlock value: ((((UIManager default
		request: aString, ' (comma separated)' initialAnswer: aDefaultList asCommaString)
		findTokens: ',') collect: [:t | t withBlanksTrimmed])).
	self changed: #contextStackList.
! !

!SDDebugger methodsFor: 'commands' stamp: 'tfel 12/27/2011 13:21'!
return

	self filteredContextStack size < 2 ifTrue: [^ self changed: #flash].
	self resetContext: self interruptedProcess stepToCallee.
! !

!SDDebugger methodsFor: 'commands' stamp: 'tfel 1/11/2012 09:57'!
safeStep
	| oldContext newContext |
	self historyIndex = 1 "Trim history index"
		ifFalse: [self history: (self history allButFirst: self history index - 1)].
	oldContext := self contextStackTop.
	newContext := #invalid.
	[(newContext = nil or: [self filterMatches: newContext])] whileFalse: [
		self interruptedProcess isTerminated ifTrue: [^ self changed: #flash].
		newContext := self interruptedProcess step.
		newContext == oldContext ifTrue: [
			newContext := self interruptedProcess stepToSendOrReturn].
		].
	self resetContext: newContext.
! !

!SDDebugger methodsFor: 'private' stamp: 'tfel 12/27/2011 19:30'!
selectedContext

	self contextStackIndex = 0
		ifTrue: [^ self filteredContextStack first]
		ifFalse: [^ self filteredContextStack at: self contextStackIndex ifAbsent: []]! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 1/2/2012 09:03'!
setClassFilter

	self request: 'Class Filter' with: self classFilter do: [:answer | classFilter := answer].

! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 1/2/2012 09:23'!
setMethodFilter

	self request: 'Negative Method Filter' with: self methodFilter do: [:answer | methodFilter := answer].

! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 1/2/2012 09:04'!
setPackageFilter

	self request: 'Package Filter' with: self packageFilter do: [:ary | packageFilter := ary].
! !

!SDDebugger methodsFor: 'commands' stamp: 'tfel 1/2/2012 09:48'!
skip

	self methodFilter: (self methodFilter
		copyWith: self contextStackTop methodClass name, '>>',
					self contextStackTop selector asString).
	self next.
! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 1/4/2012 11:01'!
transcriptBuffer
	"Answer the value of transcriptBuffer"

	^ transcriptBuffer! !

!SDDebugger methodsFor: 'accessing' stamp: 'tfel 1/4/2012 11:01'!
transcriptBuffer: anObject
	"Set the value of transcriptBuffer"

	transcriptBuffer := anObject! !

!SDDebugger methodsFor: 'transcript' stamp: 'tfel 1/4/2012 11:08'!
update: aSymbol

	super update: aSymbol.
	aSymbol caseOf: {
		[#appendEntry] ->
			["Update from TranscriptStream"
			 self transcriptBuffer nextPutAll: Transcript contents] .
		[#clearText] ->
			["Clear TranscriptStream"
			 self transcriptBuffer reset] }.
! !

!SDDebugger methodsFor: 'toolbuilder' stamp: 'tfel 12/27/2011 12:07'!
windowExtent

	^ Display height < 700 "a small screen" 
			ifTrue:[RealEstateAgent standardWindowExtent]
			ifFalse:[800@900]
! !

Notification subclass: #PromptControlNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Continuations'!

!ContextPart methodsFor: '*continuations' stamp: 'tfel 1/2/2012 10:06'!
tempsAndValuesList

	^ (self debuggerMap tempNamesForContext: self) collectWithIndex: [:title :index |
		title asString, ': ', (self debuggerMap namedTempAt: index in: self) asString]
! !

!BlockClosure methodsFor: '*continuations' stamp: 'tfel 1/3/2012 10:42'!
abort: aBlock
	| splitter |
	self isWithinExtent ifFalse: [self error: 'Out of extent #abort'].
	splitter := self value.
	thisContext swapSender: splitter.
	^ aBlock value
! !

!BlockClosure methodsFor: '*continuations' stamp: 'tfel 1/2/2012 21:37'!
callcc
	| cc |
	cc := thisContext sender copyStack.
	^ self value: [:v | 
		thisContext swapSender: cc copyStack.
		v]
! !

!BlockClosure methodsFor: '*continuations' stamp: 'tfel 1/3/2012 09:52'!
callpc: aBlock
	| cc splitter |
	self isWithinExtent ifFalse: [self error: 'Out of extent #callpc'].
	splitter := self value.
	cc := thisContext sender copyTo: splitter.
	^ aBlock value: [:arg | self ccEvaluate: cc with: arg].
! !

!BlockClosure methodsFor: '*continuations' stamp: 'tfel 1/2/2012 14:40'!
ccEvaluate: aStack with: arg
	| oldSender newSender |
	newSender := aStack copyStack.
	oldSender := thisContext swapSender: newSender.
	newSender bottomContext swapSender: oldSender.
	^ arg
! !

!BlockClosure methodsFor: '*continuations' stamp: 'tfel 1/3/2012 09:00'!
control
	| promptContext result cc |
	promptContext := PromptControlNotification signal.
	"if resetContext is nil, thisContext>>copyTo: will take a full stack snapshot"
	cc := thisContext sender copyTo: promptContext.
	result := self value: [:v | self ccEvaluate: cc with: v].
	promptContext ifNotNil: [thisContext swapSender: promptContext sender].
	^ result
! !

!BlockClosure methodsFor: '*continuations' stamp: 'tfel 1/3/2012 09:12'!
isWithinExtent

	^ thisContext hasContext: self value! !

!BlockClosure methodsFor: '*continuations' stamp: 'tfel 1/3/2012 09:00'!
prompt

	^ [self value] on: PromptControlNotification do: [:n | n resume: thisContext home].
! !

!BlockClosure methodsFor: '*continuations' stamp: 'tfel 1/3/2012 08:59'!
reset
	"Just a marker. Using a Notification doesn't seem to work. Even though the handler frame (this reset) can be copied, it won't be used for handling the ShiftResetNotification. Might be a bug in the VM"
	^ self value
! !

!BlockClosure methodsFor: '*continuations' stamp: 'tfel 1/3/2012 08:58'!
shift
	| resetContext result cc resetMethod |
	"Cannot use a Notification, see comment in #reset"
	resetMethod := self class lookupSelector: #reset.
	resetContext := thisContext findContextSuchThat: [:ctxt |
		ctxt method = resetMethod].
	resetContext ifNil: [self error: 'No enclosing #reset for #shift'].
	cc := thisContext sender copyTo: resetContext sender.
	thisContext swapSender: resetContext.
	result := self value: [:v | self ccEvaluate: cc with: v].
	^ result
! !

!BlockClosure methodsFor: '*continuations' stamp: 'tfel 1/3/2012 08:57'!
spawn
	| spawnId method |
	spawnId := thisContext asOop.
	method := self class lookupSelector: #spawn.
	^ self value: [:block || spawnFrame cc |
		spawnFrame := thisContext findContextSuchThat: [:ctxt |
			ctxt method = method
			and: [ctxt isExecutingBlock not]
			and: [(ctxt namedTempAt: 1) = spawnId]].
		spawnFrame ifNil: [self error: 'Out of context #spawn'].
		cc := thisContext sender copyTo: spawnFrame sender.
		thisContext swapSender: spawnFrame.
		block value: [:v | self ccEvaluate: cc with: v]]
! !

!BlockClosure methodsFor: '*continuations' stamp: 'tfel 1/3/2012 10:27'!
splitter
	| splitter |
	splitter := thisContext.
	^ self value: [splitter]
! !

PluggableListMorph subclass: #SDPluggableMultiLineListMorphPlus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Continuations-Utils'!

!SDPluggableMultiLineListMorphPlus methodsFor: 'accessing' stamp: 'tfel 12/27/2011 16:38'!
listMorphClass
	^ SDMultiLineLazyListMorph
! !

!SDPluggableMultiLineListMorphPlus methodsFor: 'accessing' stamp: 'tfel 12/27/2011 19:05'!
numberOfRows: aNumber

	self listMorph numberOfRows: aNumber.! !

TestCase subclass: #CCTest
	instanceVariableNames: ''
	classVariableNames: 'TestScript'
	poolDictionaries: ''
	category: 'Continuations-Test'!

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 12/20/2011 19:11'!
bar
	^ self foo * 2
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 12/20/2011 19:11'!
baz
	^ [self bar] reset
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 12/20/2011 19:12'!
foo
	^ 1 + [:k | k value: (k value: (k value: 7)) ] shift
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 1/2/2012 14:24'!
testControlWithoutReset

	self assert: [[:k | k value: 7 ] control = 7].
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 1/3/2012 10:29'!
testHLCPromptControl
	"(prompt (* 2 (control (lambda (f) 3)))) -> 3
	(prompt (* 2 (control (lambda (f) (* 5 (f 3)))))) -> 30
	(prompt (* 2 (control (lambda (f) (f (f 3)))))) -> 12
	((prompt (* 2 (control (lambda (f) f)))) 3) -> 6
	(prompt (* 5
		(prompt (* 2
			(control (lambda (f2)
				(* 3 (control (lambda (f3)
					7 ))) )) )) )) -> 35
	(prompt (* 5 (
		(prompt (* 2
			(control (lambda (f2)
				(lambda ()
					(* 3 (control (lambda (f3) 7 ))) ) )) )) ))) -> 7
	(prompt (* 5
		((lambda (x)
			(control (lambda (f1)
						x )) )
		(* 3 (control (lambda (f2)
			(* 2 (f2 7)) ))) ) )) -> 21"
	
	self assert: (3 = [2 * [:f | 3] control] prompt).
	self assert: (30 = [2 * [:f | 5 * (f value: 3)] control] prompt).
	self assert: (12 = [2 * [:f | f value: (f value: 3)] control] prompt).
	self assert: (6 = (([2 * [:f | f] control] prompt) value: 3)).
	self assert: (35 = [5 * [2 * [:f2 | 3 * [:f3 | 7] control] control] prompt] prompt).
	self assert: (7 = [5 * ([2 * [:f2 | [3 * [:f3 | 7] control]] control] prompt) value] prompt).
	self assert: (21 = [5 * ([:x | [:f1 | x] control] value: (3 * [:f2 | 2 * (f2 value: 7)] control))] prompt).! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 1/3/2012 10:30'!
testHLCShiftReset
	"see testHLCPromptControl for scheme code"
	self assert: (3 = [2 * [:f | 3] shift] reset).
	self assert: (30 = [2 * [:f | 5 * (f value: 3)] shift] reset).
	self assert: (12 = [2 * [:f | f value: (f value: 3)] shift] reset).
	self assert: (6 = (([2 * [:f | f] shift] reset) value: 3)).
	self assert: (35 = [5 * [2 * [:f2 | 3 * [:f3 | 7] shift] shift] reset] reset).
	self assert: (7 = [5 * ([2 * [:f2 | [3 * [:f3 | 7] shift]] shift] reset) value] reset).
	self assert: (42 = [5 * ([:x | [:f1 | x] shift] value: (3 * [:f2 | 2 * (f2 value: 7)] shift))] reset).
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 1/3/2012 10:30'!
testHLCSpawn
	"see testHLCPromptControl for some scheme code"
	self assert: (3 = [:c | 2 * (c value: [:f | 3])] spawn).
	self assert: (30 = [:c | 2 * (c value: [:f | 5 * (f value: 3)])] spawn).
	self assert: (12 = [:c | 2 * (c value: [:f | f value: (f value: 3)])] spawn).
	self assert: 6 = ([:c | 2 * (c value: [:f | f])] spawn value: 3).
	self assert: (35 = [:c1 |
						5 * [:c2 |
							2 * (c2 value: [:f2 |
									3 * (c2 value: [:f3 | 7])])] spawn ] spawn).
	self assert: (7 = [:c1 |
						5 * ([:c2 |
								2 * (c2 value: [:f2 |
									[3 * (c1 value: [:f3 | 7])]])] spawn) value] spawn).
	"(spawn (lambda (c1)
		(* 5 ((spawn (lambda (c2)
			(* 2 (c2 (lambda (f2)
						(lambda ()
							(* 3 (c2 (lambda (f3)
										7 ))) ) ))) )))) )) -> raises OutOfExtent"
	self should: [
			[:c1 | 5 * ([:c2 |
						2 * (c2 value: [:f2 |
								[3 * (c2 value: [:f3 | 7])]])] spawn) value] spawn
		] raise: Error.
	"(spawn (lambda (c)
		(* 5 ((lambda (x) (c (lambda (f1) x)))
			  (* 3 (c (lambda (f2) (* 2 (f2 7))))) )) )) -> 42"
	self assert: 42 = 
		[:c | 5 * ([:x | c value: [:f1 | x]] value: (3 * (c value: [:f2 | 2 * (f2 value: 7)])))] spawn.
	
	"Mind-boggler:
	((spawn (lambda (c1)
			(* 5 (spawn (lambda (c2)
						(* 2 ((c1 (lambda (f1)
								   (lambda (g) (g f1 c2)) ))) ))) ))
	 ;;let be the value of the following term. It will be bound to g.
	 (lambda (f1 c2) (f1 (lambda () (* 7 (c2 (lambda (f2)
											(* 11 (f2 13)) )))))) ) -> 10010 i.e., 5*11*2*7*13"
	self assert: 10010 = (([:c1 |
		5 * [:c2 |
				2 * (c1 value: [:f1 |
								[:g | g value: f1 value: c2] ]) value ] spawn ] spawn) value:
		[:f1 :c2 | f1 value: [7 * (c2 value: [:f2 | 11 * (f2 value: 13)])]]).
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 1/3/2012 10:42'!
testHLCSplitterAbortCallpc
	"(splitter (lambda (m) (* 2 (call/pc m (lambda (f)
										(abort m (lambda ()
													(f (f 3)) )) ))))) !! 12"
	self assert: 12 = [:m | 2 * (m callpc: [:f | m abort: [f value: (f value: 3)]])] splitter.
	"(splitter (lambda (m) (* 2 (call/pc m (lambda (f) (f (f 3))))))) !! 24"
	self assert: 24 = [:m | 2 * (m callpc: [:f | f value: (f value: 3)])] splitter.
	"((splitter (lambda (m) (* 2 (call/pc m (lambda (f) (abort m (lambda () f)) ))))) 3 ) !! 6"
	self assert: 6 = ([:m | 2 * (m callpc: [:f | m abort: [f]])] splitter value: 3).
	"(splitter (lambda (m1)
				(* 5 (splitter (lambda (m2)
								(* 2 (call/pc m2 (lambda (f2)
													(* 3 (call/pc m2 (lambda (f3) 7 ))) ))) ))) ))
		!! 210"
	self assert: 210 = [:m1 | 5 * [:m2 | 2 * (m2 callpc: [:f2 |
							3 * (m2 callpc: [:f3 | 7])])] splitter] splitter.
	"((splitter (lambda (m1)
				(* 5 (splitter
					  (lambda (m2)
						(* 2 ((call/pc m1 (lambda (f1)
											(abort m1 (lambda ()
														(lambda (g) (g f1 m2))
														)) )))) ))) ))
	   (lambda (f1 m2) (f1 (lambda ()
							(* 7 (call/pc m2 (lambda (f2) (* 11 (f2 13))))) ))) )
	!! OutOfExtent wrt m2"
	self should: [
		[:m1 |
		5 * [:m2 | 2 * (m1 callpc: [:f1 | (m1 abort: [[:g | g value: f1 value: m2]])]) value] splitter]
		splitter value: ([:f1 :m2 | f1 value: [7 * (m2 callpc: [:f2 | 11 * (f2 value: 13)])]])]
	raise: Error.
	"(splitter (lambda (m)
		(* 5 ((lambda (x)
				(call/pc m (lambda (f1) (abort m (lambda () x )))))
			(* 3 (call/pc m (lambda (f2) (abort m (lambda () (* 2 (f2 7)))) !! 21"
	self assert: 21 = [:m | 5 * ([:x | m callpc: [:f1 | m abort: [x]]] value: 
						(3 * (m callpc: [:f2 | m abort: [2 * (f2 value: 7)]])))] splitter.
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 12/20/2011 19:13'!
testMultiMethodShiftReset

	self assert: [self baz = 70]
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 12/20/2011 19:07'!
testNLJump
	| continuation return |
	TestScript := ''.
	continuation := nil.
	return := [:cc | continuation := cc. false] callcc.
	return ifFalse: [
			TestScript := TestScript, 'Hello '.
			continuation value: true.
			TestScript := TestScript, 'World'].
	TestScript := TestScript, 'HPI'.
	self assert: [TestScript = 'Hello HPI'].
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 12/20/2011 19:50'!
testNestedResets
	| result |
	result := [[:c || cc |
		cc := [[:k | k ] shift, #(innerPartialCc)] reset.
		c value: (cc value: #(innerCall)), #(outerCall)] shift, #(outerPartialCc)] reset.
	self assert: result = #(innerCall innerPartialCc outerCall outerPartialCc)
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 1/2/2012 10:52'!
testNestedShiftWithReset

	self assert: [
		[[:k | k value: (k value: (k value: 7)) ] shift + 1
		] reset * 2 = 20
	].
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 12/20/2011 19:07'!
testNoGOTO
	| continuation count |
	TestScript := 10.
	count := 10.

	continuation := [:cc | cc] callcc.

	count := count - 1.
	TestScript := TestScript - 1.
	
	TestScript > 0 ifTrue: [continuation value: continuation].

	self assert: [count = 9].
	self assert: [TestScript = 0].
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 12/20/2011 19:51'!
testPassingShiftAround
	| cc |
	[[:k | cc := k. 1] shift + 1] reset * 2.
	cc value: 10.
	self assert: (cc value: 10) = 11. "10 + 1"
	
	[[:k | cc := k. 1] shift + self baz * 2] reset.
	cc value: 10.
	self assert: (cc value: 10) = 160. "10 + self baz (= 70) * 2"

! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 1/2/2012 10:49'!
testPromptControlEnclosure

	"(prompt (* 5
		((lambda (x)
			(control f1 x) )
		 (* 3 (control f2 (* 2 (f2 7)) -> 21"
	| result |
	result := [ 5 *
				([:x | [:f1 | x] control] value:
				(3 * [:f2 | 2 * (f2 value: 7)] control))
			  ] prompt.
	self assert: result = 21! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 12/20/2011 17:53'!
testShiftDiscardWithReset

	self assert: [
		[
			[:k |
				k value: (k value: (k value: 7)).
				'done' ] shift + 1
		] reset = 'done'
	].
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 1/2/2012 14:26'!
testShiftResetDiverges

	self assert: [[:k | 'done here' ] shift] reset = 'done here'.
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 1/2/2012 15:35'!
testShiftResetEnclosure

	"(reset (* 5
		((lambda (x)
			(shift f1 x) )
		 (* 3 (shift f2 (* 2 (f2 7)) -> 42"
	| result |
	result := [ 5 *
				([:x | [:f1 | x] shift] value:
					([:x | [:f2 | 10 * x] shift] value:
						(3 * [:f3 | 2 * (f3 value: 7)] shift)))
			  ] reset.
	self assert: result = 420.! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 12/21/2011 10:59'!
testShiftToControlExample
	| list |
	list := #(a), [
			#(b), [:f |
				#(1),
					(f value: (f value: #(c))) ] shift] reset.
	self assert: list = #(a 1 b b c).
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 1/2/2012 14:24'!
testShiftWithoutReset

	self should: [[:k | k value: 7 ] shift = 7] raise: Error
! !

!CCTest methodsFor: 'as yet unclassified' stamp: 'tfel 12/20/2011 19:14'!
testSimpleShiftWithReset

	self assert: [
		[[:k | k value: 7 ] shift + 1
		] reset * 2 = 16
	].
! !

Object subclass: #CCConsumer
	instanceVariableNames: ''
	classVariableNames: 'HardWork'
	poolDictionaries: ''
	category: 'Continuations-Test'!

!CCConsumer class methodsFor: 'as yet unclassified' stamp: 'tfel 12/27/2011 20:00'!
expensiveClasses

	^ {SortedCollection}! !

!CCConsumer class methodsFor: 'as yet unclassified' stamp: 'tfel 12/27/2011 20:18'!
hardWork

	^ CCProducer hardWork! !

!CCConsumer class methodsFor: 'as yet unclassified' stamp: 'tfel 12/27/2011 19:47'!
resultQueue

	^ CCProducer results! !

!CCConsumer class methodsFor: 'as yet unclassified' stamp: 'tfel 12/27/2011 19:42'!
workQueue

	^ CCProducer work! !

!CCConsumer methodsFor: 'as yet unclassified' stamp: 'tfel 1/2/2012 10:10'!
consume
	| class array selector |
	[self class workQueue isEmpty] whileFalse: [| worklist |
		worklist := self class workQueue pop.
		class := (Smalltalk globals at: worklist first).
		selector := worklist second.
		array := worklist last.
		[self class resultQueue push: (self createInstanceOf: class with: array using: selector)] reset].
! !

!CCConsumer methodsFor: 'as yet unclassified' stamp: 'tfel 12/27/2011 20:00'!
createInstanceOf: class with: array using: selector

	(self class expensiveClasses includes: class)
		ifTrue: [[:k | self class hardWork push: k] shift].
	^ class perform: selector with: array
! !

Object subclass: #CCExamples
	instanceVariableNames: ''
	classVariableNames: 'GlobalCount'
	poolDictionaries: ''
	category: 'Continuations-Test'!

CCExamples class
	instanceVariableNames: 'lastExceptionHandler lastDecision transcripter'!

CCExamples class
	instanceVariableNames: 'lastExceptionHandler lastDecision transcripter'!

!CCExamples class methodsFor: 'backtracking' stamp: 'tfel 1/4/2012 09:31'!
assertPickSatisfies: aBoolean

	aBoolean ifFalse: [self fail].
! !

!CCExamples class methodsFor: 'exceptions' stamp: 'tfel 1/4/2012 11:13'!
exceptionHandler
	Transcript clear.
	lastExceptionHandler := [:e | self inform: 'unhandled exception: ', e].
	self throw: 'See if the default global exception handler works...'.
	#(2 1 0) do: [:num |
		self
			try: [
				num = 0
					ifFalse: [Transcript show: (num / 10); cr]
					ifTrue: [self throw: 'Zero-division error']]
			catch: [:e |
				Transcript show: e; cr.
				self inform: 'An exception was handled. Details were printed to the Transcript']].
	Transcript show: 'Done'; cr.! !

!CCExamples class methodsFor: 'backtracking' stamp: 'tfel 1/4/2012 09:24'!
fail
	"Jump back to the last decision point"
	lastDecision value: #fail.! !

!CCExamples class methodsFor: 'goto' stamp: 'tfel 1/11/2012 10:07'!
goto
	| continuation localCount |
	GlobalCount := 3.
	localCount := 3.

	continuation := [:cc | cc] callcc.
	Transcript show: 'localCount: ', localCount; cr.
	Transcript show: 'GlobalCount: ', GlobalCount; cr.

	localCount := localCount - 1.
	GlobalCount := GlobalCount - 1.

	GlobalCount > 0 ifTrue: [
		continuation value: continuation].
! !

!CCExamples class methodsFor: 'helpers' stamp: 'tfel 1/4/2012 11:04'!
inform: aString

	Transcript
		cr;
		show: '[INFORMATION]: ', aString;
		cr.
! !

!CCExamples class methodsFor: 'setjmp-longjmp' stamp: 'tfel 1/4/2012 11:14'!
longjmp
	| continuation return |
	Transcript clear.
	continuation := nil.
	return := [:cc | continuation := cc. false] callcc. "setjmp"
	return ifFalse: [
			Transcript show: 'Hello '.
			continuation value: true. "longjmp"
			Transcript show: 'World'].
	Transcript show: 'HPI'.
! !

!CCExamples class methodsFor: 'backtracking' stamp: 'tfel 1/4/2012 09:15'!
next
	"We aren't satisfied with the result, 'fail' it"
	self fail.
! !

!CCExamples class methodsFor: 'backtracking' stamp: 'tfel 1/4/2012 09:17'!
pickValueFrom: anArray
	| secondToLastDecision |
	secondToLastDecision := lastDecision.
	^ [:return |
		anArray do: [:argument |
			[:next |
				lastDecision := next.
				return value: argument] callcc].
		lastDecision := secondToLastDecision.
		lastDecision value: #f] callcc
! !

!CCExamples class methodsFor: 'tail-recursion' stamp: 'tfel 1/9/2012 15:59'!
pseudoTailRecursiveFactorial: n

	^ self pseudoTailRecursiveFactorial: n sum: 1
! !

!CCExamples class methodsFor: 'tail-recursion' stamp: 'tfel 1/9/2012 15:59'!
pseudoTailRecursiveFactorial: n sum: acc

	n = 0 ifTrue: [^ acc].
	^ self pseudoTailRecursiveFactorial: n - 1 sum: acc * n
! !

!CCExamples class methodsFor: 'tail-recursion' stamp: 'tfel 1/9/2012 15:38'!
recursiveFactorial: n
	n = 0
		ifTrue: [^ 1]
		ifFalse: [(self recursiveFactorial: n - 1) * n].
! !

!CCExamples class methodsFor: 'tail-recursion' stamp: 'tfel 1/11/2012 10:04'!
tailRecursiveFactorial: n
	| acc i cont tempArray |
	tempArray := [:cc | cont := cc. { n . 1 }] callcc.
	i := tempArray first.
	acc := tempArray second.
	i = 0
		ifTrue: [^ acc]
		ifFalse: [cont value: { i - 1 . acc * i }].
! !

!CCExamples class methodsFor: 'backtracking' stamp: 'tfel 1/4/2012 11:14'!
threeDice: sumTo
	| dice |
	Transcript clear.
	lastDecision := [:x | self error: 'tree exhausted'].
	dice := (1 to: 3) collect: [:i |
		self pickValueFrom: (1 to: 6)].
	self assertPickSatisfies: (sumTo = (dice first + dice second + dice third)).
	Transcript
		show: dice first;
		space;
		show: dice second;
		space;
		show: dice third;
		cr.
! !

!CCExamples class methodsFor: 'exceptions' stamp: 'tfel 1/3/2012 13:32'!
throw: aString

	lastExceptionHandler value: aString.! !

!CCExamples class methodsFor: 'exceptions' stamp: 'tfel 1/3/2012 13:39'!
try: aBlock catch: catchBlock
	| oldHandler error |
	oldHandler := lastExceptionHandler.
	error := [:cc | lastExceptionHandler := cc. #noError] callcc.
	error = #noError
		ifTrue: aBlock
		ifFalse: [
			lastExceptionHandler := oldHandler.
			catchBlock value: error].
! !

!CCExamples methodsFor: 'stack' stamp: 'tfel 1/8/2012 15:45'!
makeOne
	| myShare |
	myShare := 1.
	^ myShare! !

!CCExamples methodsFor: 'cps' stamp: 'tfel 1/8/2012 16:39'!
makeOne: k
	| myShare |
	myShare := 1.
	k value: myShare! !

!CCExamples methodsFor: 'stack' stamp: 'tfel 1/8/2012 15:45'!
makeThree
	| myShare |
	myShare := 1.
	^ self makeTwo + myShare! !

!CCExamples methodsFor: 'cps' stamp: 'tfel 1/8/2012 16:39'!
makeThree: k
	| myShare |
	myShare := 1.
	self makeTwo: [:x | k value: x + myShare]! !

!CCExamples methodsFor: 'stack' stamp: 'tfel 1/8/2012 15:45'!
makeTwo
	| myShare |
	myShare := 1.
	^ self makeOne + myShare! !

!CCExamples methodsFor: 'cps' stamp: 'tfel 1/8/2012 16:39'!
makeTwo: k
	| myShare |
	myShare := 1.
	self makeOne: [:x | x + myShare]! !

Object subclass: #CCHardWorker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Continuations-Test'!

!CCHardWorker class methodsFor: 'as yet unclassified' stamp: 'tfel 12/27/2011 20:17'!
workQueue

	^ CCProducer hardWork! !

!CCHardWorker methodsFor: 'as yet unclassified' stamp: 'tfel 1/2/2012 14:50'!
work
	| continuation |
	[self class workQueue isEmpty] whileFalse: [
		continuation := self class workQueue pop.
		continuation value: nil]
! !

Object subclass: #CCProducer
	instanceVariableNames: ''
	classVariableNames: 'HardWork Results Work'
	poolDictionaries: ''
	category: 'Continuations-Test'!

!CCProducer class methodsFor: 'accessing' stamp: 'tfel 12/27/2011 20:17'!
hardWork

	^ HardWork ifNil: [HardWork := Stack new]! !

!CCProducer class methodsFor: 'accessing' stamp: 'tfel 12/27/2011 20:17'!
reset

	Work := nil.
	Results := nil.
	HardWork := nil.! !

!CCProducer class methodsFor: 'accessing' stamp: 'tfel 12/27/2011 19:49'!
results

	^ Results ifNil: [Results := Stack new]! !

!CCProducer class methodsFor: 'example' stamp: 'tfel 12/27/2011 20:17'!
softwareDesignDemo

	| consumer hardWorker producer |
	self reset.
	producer := self new.
	consumer := CCConsumer new.
	hardWorker := CCHardWorker new.
	producer produceWork.
	consumer consume.
	hardWorker work.! !

!CCProducer class methodsFor: 'accessing' stamp: 'tfel 12/27/2011 19:49'!
work

	^ Work ifNil: [Work := Stack new]! !

!CCProducer methodsFor: 'as yet unclassified' stamp: 'tfel 1/2/2012 10:15'!
produceWork
	| collection worklist |
	worklist := self class work.
	collection := #(5 212 4 2 122 332 44 31 32 21).
	{ {#Bag . #newFrom: . collection}.
	  {#SortedCollection . #newFrom: . collection}.
	  {#Array . #newFrom: . collection}.
	  {#SortedCollection . #newFrom: . collection}. } do: [:workitem |
		worklist push: workitem ].
! !
